<script>
	import moment from 'moment';
	import axios from 'axios';

	let api = {
		create: async function(data) {
			return await axios.post(`${window.location.href}api/cash-register`, data).then(res => {
				if (res.status !== 201) {
					alert('Erooooooooooooor :-)')
				}
			});
		},
		getLastRecord: async function() {
			return await axios.get(`${window.location.href}api/cash-register/get-last`).then(res => {
				if (res.status !== 200) {
					alert('Erooooooooooooor :-)')
				}		
				return res.data;
			});
		}
	}

	export default {
		data() {
			return {
				cisloPokladny: 2,
				cisloPredajny: 123,
				mezisoucet: 0,
				celkovySucet: 0,
				stranouDoBanky: 0,
				rezerva: 0,
				dateTime: null,
				bankovky: [
					{
						value: 500,
						count: 0,
						sum: 0,
					},
					{
						value: 200,
						count: 0,
						sum: 0,
					},
					{
						value: 100,
						count: 0,
						sum: 0,
					},
					{
						value: 50,
						count: 0,
						sum: 0,
					},
					{
						value: 20,
						count: 0,
						sum: 0,
					},
					{
						value: 10,
						count: 0,
						sum: 0,
					},
					{
						value: 5,
						count: 0,
						sum: 0,
					},
					{
						value: 2,
						count: 0,
						sum: 0,
					},
					{
						value: 1,
						count: 0,
						sum: 0,
					},
					{
						value: 0.50,
						count: 0,
						sum: 0,
					},
					{
						value: 0.20,
						count: 0,
						sum: 0,
					},
					{
						value: 0.10,
						count: 0,
						sum: 0,
					},
					{
						value: 0.05,
						count: 0,
						sum: 0,
					},
					{
						value: 0.02,
						count: 0,
						sum: 0,
					},
					{
						value: 0.01,
						count: 0,
						sum: 0,
					},
				]
			}
		},
		methods: {
			calcMezisoucet() {
				let sum = 0;
				this.bankovky.forEach((bankovka) => {
					sum += bankovka.value * bankovka.count
				});				
				this.mezisoucet = sum.toFixed(2);
				this.calcCelkovySucet();
			},
			calcCelkovySucet() {
				this.celkovySucet = (Number(this.mezisoucet)
					+ Number(this.stranouDoBanky)
					+ Number(this.rezerva)).toFixed(2)
			},
			sucetBankoviek(bankovka) {
				bankovka.sum = (bankovka.value * bankovka.count).toFixed(2);
				this.calcMezisoucet();
			},
			ulozit() {
				this.dateTime = moment().format('YYYY-MM-DDTHH:mm');
				api.create({
					cislo_pokladny: this.cisloPokladny,
					cislo_predajny: this.cisloPredajny,
					celkova_castka: this.celkovySucet,
					stranou_do_banky: this.stranouDoBanky,
					rezerva: this.rezerva,
					bankovky: this.bankovky
				});
			},
			async getLastRecord() {
				let lastRecord = await api.getLastRecord();
				if (typeof lastRecord !== 'object') {
					return;
				}
				this.bankovky = lastRecord.bankovky;
				this.stranouDoBanky = lastRecord.stranou_do_banky;
				this.rezerva = lastRecord.rezerva;
				this.dateTime = moment(lastRecord.created_at).format('YYYY-MM-DDTHH:mm');
				this.calcMezisoucet();
			},
			vymazat() {
				this.bankovky.forEach((bankovka) => {
					bankovka.count = 0;
					bankovka.sum = 0;
				});
				this.stranouDoBanky = 0;
				this.rezerva = 0;
				this.dateTime = null;
				this.calcMezisoucet();
			},
			isNumber: function(evt) {
				evt = (evt) ? evt : window.event;
				var charCode = (evt.which) ? evt.which : evt.keyCode;
				if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
					evt.preventDefault();
					this.calcMezisoucet()
				} else {
					this.calcMezisoucet()
					return true;
				}
			}
		},
		async mounted() {
			this.getLastRecord()
		}
	}
</script>

<template>
	<div class="container p-2">
		<table>
			<tr>
				<td class="info">POKLADNA {{ cisloPokladny }}</td>
				<td></td>
				<td class="info">HODNOTA BANKOVKY</td>
			</tr>
			<tr class="my-1" v-for="bankovka in bankovky" :key="bankovka.value">
				<td>
					<input type="text" class="input"
						v-model="bankovka.count"
						@keypress="isNumber($event)"
						@input="sucetBankoviek(bankovka)"
					>
				</td>
				<td><span class="span">x</span></td>
				<td>
					<input type="text" class="input" v-model="bankovka.value" disabled>
				</td>
				<td><span class="span">=</span></td>
				<td>
					<input type="text" class="input input-sum" v-model="bankovka.sum" disabled>
				</td>
			</tr>
			<tr>
				<td colspan="4" class="info ta-left">MEZISOUČET</td>
				<td>
					<input type="text" class="input input-sum" v-model="mezisoucet" disabled>
				</td>
			</tr>
			<tr>
				<td colspan="4" class="info ta-left">STRANOU DO BANKY</td>
				<td>
					<input type="text" class="input input-sum" 
						v-model="stranouDoBanky" 
						@keypress="isNumber($event)"
						@input="calcMezisoucet()"
					>
				</td>
			</tr>
			<tr>
				<td colspan="4" class="info ta-left">REZERVA</td>
				<td>
					<input type="text" class="input input-sum" 
						v-model="rezerva" 
						@keypress="isNumber($event)"
						@input="calcMezisoucet()"
					>
				</td>
			</tr>
			<tr>
				<td colspan="4" class="info ta-left">SOUČET</td>
				<td>
					<input type="text" class="input input-sum celkovy-sucet" v-model="celkovySucet" disabled>
				</td>
			</tr>
			<tr>
				<td colspan="4" class="info ta-left" style="text-align: left;">
					<input class="datetime" type="datetime-local" v-model="dateTime" disabled>
				</td>
				<td>
					<button class="submit" @click="ulozit()">ULOŽIŤ</button>
				</td>
			</tr>
			<tr>
				<td colspan="5" class="pt-4" style="text-align: center;">
					<button class="submit" @click="vymazat()">VYMAZAŤ FORMULÁR</button>
				</td>
			</tr>
		</table>
	</div>	
</template>

<style>
	.container {
		background-color: #98fe90;
		width: 315px;
		padding-left: auto;
		padding-right: 0;
	}
	.input {
		width: 75px;
		text-align: right;
		font-weight: bold;
	}
	.input-sum {
		width: 100px;
	}
	.span {
		font-weight: bold;
		margin: 0px 5px 0px 5px;
	}
	.info {
		font-size: 11px;
		font-weight: bold;
	}
	.ta-left {
		text-align: right;
		padding-right: 5px;
	}
	.celkovy-sucet {
		background-color: white;
		color: green;
	}
	.submit {
		font-size: 14px;
		font-weight: bold;
	}
	.datetime {
		font-size: 14px;
		font-weight: bold;
		background-color: white;
	}
</style>